// jl: wie letztes Mal, aber nun mit Texturen

#include "stdafx.h"
#include "resource.h"

#define MAX_LOADSTRING 100

const double PI = 4.0*atan(1.0);

// Globale Variablen:
HINSTANCE hInst; // aktuelle Instanz
TCHAR szTitle[MAX_LOADSTRING]; // Text der Titelzeile
TCHAR szWindowClass[MAX_LOADSTRING]; // Text der Titelzeile

// Vorausdeklarationen von Funktionen, die in diesem Code-Modul enthalten sind:
ATOM				MyRegisterClass( HINSTANCE hInstance );
BOOL				InitInstance( HINSTANCE, int );
LRESULT CALLBACK	WndProc( HWND, UINT, WPARAM, LPARAM );
LRESULT CALLBACK	About( HWND, UINT, WPARAM, LPARAM );

static unsigned char* myTexture;
static int texWidth, texHeight;

double frac(double x)
{
	return x-(int)x;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
 	// ZU ERLEDIGEN: Fgen Sie hier den Code ein.
	MSG msg;
	HACCEL hAccelTable;

	// Globale Zeichenfolgen initialisieren
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_OGLRUMPFPROGRAMM, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// jl
	// Textur laden: RGB und Alpha
	// Beides mssen hier 24-Bit-BMP-Ressourcen sein.
	// Bildbreite und -hhe mssen Zweierpotenzen und Vielfache von 4 sein.

	HRSRC bmpRes = FindResource(hInstance, MAKEINTRESOURCE(IDB_RGB), RT_BITMAP);
	if(!bmpRes)
	{
		return FALSE;
	}
	HGLOBAL hBmpRes = LoadResource(hInstance, bmpRes);
	if(!hBmpRes)
	{
		return FALSE;
	}
	BITMAPINFO* pBmp = (BITMAPINFO*)LockResource(hBmpRes);
	if(!pBmp)
	{
		return FALSE;
	}
	texHeight = pBmp->bmiHeader.biHeight;
	texWidth = pBmp->bmiHeader.biWidth;
	// Checke korrekte Abmessungen
	if(texHeight%4 != 0
		|| texWidth%4 != 0
		|| fabs(frac(log(texHeight)/log(2)))>1e-10
		|| fabs(frac(log(texWidth)/log(2)))>1e-10
		|| pBmp->bmiHeader.biBitCount != 24)
	{
		return FALSE;
	}

	myTexture = new unsigned char[4*texHeight*texWidth];

	int i;
	for(i=0; i<texHeight*texWidth; ++i)
	{
		myTexture[4*i] = // Bytefolge in BMP-Datei ist BGR statt RGB
			(((unsigned char*)pBmp) + pBmp->bmiHeader.biSize)[3*i+2];
		myTexture[4*i+1] =
			(((unsigned char*)pBmp) + pBmp->bmiHeader.biSize)[3*i+1];
		myTexture[4*i+2] =
			(((unsigned char*)pBmp) + pBmp->bmiHeader.biSize)[3*i  ];
		myTexture[4*i+3] = 255; // Alpha nicht aus Datei
	}

	DeleteObject(hBmpRes);

	bmpRes = FindResource(hInstance, MAKEINTRESOURCE(IDB_ALPHA), RT_BITMAP);
	if(!bmpRes)
	{
		return FALSE;
	}
	hBmpRes = LoadResource(hInstance, bmpRes);
	if(!hBmpRes)
	{
		return FALSE;
	}
	pBmp = (BITMAPINFO*)LockResource(hBmpRes);
	if(!pBmp)
	{
		return FALSE;
	}
	// Checke korrekte Abmessungen
	if(texHeight != pBmp->bmiHeader.biHeight
		|| texWidth != pBmp->bmiHeader.biWidth
		|| pBmp->bmiHeader.biBitCount != 24)
	{
		return FALSE;
	}

	for(i=0; i<texHeight*texWidth; ++i)
	{
		myTexture[4*i+3] =
			(((unsigned char*)pBmp) + pBmp->bmiHeader.biSize)[3*i];
	}

	DeleteObject(hBmpRes);

	// Initialisierung der Anwendung durchfhren:
	if( !InitInstance( hInstance, nCmdShow ) ) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_OGLRUMPFPROGRAMM);

	// Hauptnachrichtenschleife:
	while( GetMessage(&msg, NULL, 0, 0) ) 
	{
		if( !TranslateAccelerator (msg.hwnd, hAccelTable, &msg) ) 
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}

	delete[] myTexture;

	return msg.wParam;
}

//
//  FUNKTION: MyRegisterClass()
//
//  AUFGABE: Registriert die Fensterklasse.
//
//  KOMMENTARE:
//
//    Diese Funktion und ihre Verwendung sind nur notwendig, wenn dieser Code
//    mit Win32-Systemen vor der 'RegisterClassEx'-Funktion kompatibel sein soll,
//    die zu Windows 95 hinzugefgt wurde. Es ist wichtig diese Funktion aufzurufen,
//    damit der Anwendung kleine Symbole mit den richtigen Proportionen zugewiesen
//    werden.
//
ATOM MyRegisterClass( HINSTANCE hInstance )
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC; // jl: CS_OWNDC dazu
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_OGLRUMPFPROGRAMM);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)NULL; // jl: NULL
	wcex.lpszMenuName	= (LPCSTR)IDC_OGLRUMPFPROGRAMM;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNKTION: InitInstance(HANDLE, int)
//
//   AUFGABE: Speichert die Instanzzugriffsnummer und erstellt das Hauptfenster
//
//   KOMMENTARE:
//
//        In dieser Funktion wird die Instanzzugriffsnummer in einer globalen Variable
//        gespeichert und das Hauptprogrammfenster erstellt und angezeigt.
//
BOOL InitInstance( HINSTANCE hInstance, int nCmdShow )
{
   HWND hWnd;

   hInst = hInstance; // Instanzzugriffsnummer in unserer globalen Variable speichern

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if( !hWnd ) 
   {
      return FALSE;
   }

   ShowWindow( hWnd, nCmdShow );
   UpdateWindow( hWnd );

   return TRUE;
}

void drawUnitSphere(int slices, int stacks) // vergleiche gluSphere
{
	int sl;
	int st;
	double dTheta = PI/(double)stacks;
	double dPhi = 2.0*PI/(double)slices;

	glBegin(GL_QUADS); // besser mit Quadstrips oder Vertexarray
	for(st = 0; st < stacks; ++st)
	{
		double theta = st*dTheta;
		for(sl = 0; sl < slices-1; ++sl)
		{
			double phi = sl*dPhi;
			// viel zu aufwendig: alle Winkelfunktionen doppelt berechnet;
			// einige knnte man sogar aus der inneren Schleife holen;
			// noch besser: vorab berechnen
			glNormal3d(sin(theta)*cos(phi), sin(theta)*sin(phi), cos(theta));
			glVertex3d(sin(theta)*cos(phi), sin(theta)*sin(phi), cos(theta));

			glNormal3d(sin(theta+dTheta)*cos(phi), sin(theta+dTheta)*sin(phi), cos(theta+dTheta));
			glVertex3d(sin(theta+dTheta)*cos(phi), sin(theta+dTheta)*sin(phi), cos(theta+dTheta));

			glNormal3d(sin(theta+dTheta)*cos(phi+dPhi), sin(theta+dTheta)*sin(phi+dPhi), cos(theta+dTheta));
			glVertex3d(sin(theta+dTheta)*cos(phi+dPhi), sin(theta+dTheta)*sin(phi+dPhi), cos(theta+dTheta));

			glNormal3d(sin(theta)*cos(phi+dPhi), sin(theta)*sin(phi+dPhi), cos(theta));
			glVertex3d(sin(theta)*cos(phi+dPhi), sin(theta)*sin(phi+dPhi), cos(theta));
		}

		glNormal3d(sin(theta)*cos(-dPhi), sin(theta)*sin(-dPhi), cos(theta));
		glVertex3d(sin(theta)*cos(-dPhi), sin(theta)*sin(-dPhi), cos(theta));

		glNormal3d(sin(theta+dTheta)*cos(-dPhi), sin(theta+dTheta)*sin(-dPhi), cos(theta+dTheta));
		glVertex3d(sin(theta+dTheta)*cos(-dPhi), sin(theta+dTheta)*sin(-dPhi), cos(theta+dTheta));

		glNormal3d(sin(theta+dTheta), 0.0, cos(theta+dTheta));
		glVertex3d(sin(theta+dTheta), 0.0, cos(theta+dTheta));

		glNormal3d(sin(theta), 0.0, cos(theta));
		glVertex3d(sin(theta), 0.0, cos(theta));
	}
	glEnd();
}

//
//  FUNKTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  AUFGABE:  Verarbeitet Nachrichten fr das Hauptfenster.
//
//  WM_COMMAND	- Anwendungsmen verarbeiten
//  WM_PAINT	- Hauptfenster darstellen
//  WM_DESTROY	- Beendigungsnachricht ausgeben und zurckkehren
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	static HDC hDC = NULL;
	static HGLRC hRC = NULL;

	static double angleH = 13.0;
	static double angleV = 15.0;

	switch( message ) 
	{
		case WM_CREATE: // jl: ganz neu
			{ // Block, weil lokale Variablen
				hDC = GetDC(hWnd); // zum ersten und letzten Mal,
									// weil wir den DC besitzen
				static PIXELFORMATDESCRIPTOR pfd = {
					sizeof(PIXELFORMATDESCRIPTOR),
					1,
					PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
					PFD_TYPE_RGBA,
					32,
					0,0,0,0,0,0,0,0,0,0,0,0,0,
					16, // Bit-Tiefe des z-Buffer
					0,0,0,0,0,0,0 };
				int nPixelFormat = ChoosePixelFormat(hDC, &pfd);
				if(nPixelFormat != 0)
				{
					SetPixelFormat(hDC, nPixelFormat, &pfd);
					hRC = wglCreateContext(hDC);
				}
				else
				{
					MessageBox(hWnd, "Initialisierung von OpenGL fehlgeschlagen.", "Fataler Fehler", MB_ICONERROR);
					PostQuitMessage(0);
				}
			}
			break;
		case WM_SIZE: // jl: neu
			{ // Block, weil lokale Variablen
				wglMakeCurrent(hDC, hRC);
				RECT r;
				GetClientRect(hWnd, &r);
				glViewport(r.left, r.top, r.right-r.left, r.bottom-r.top);

				// jl: neu: View Frustum an Fenster anpassen
				glMatrixMode(GL_PROJECTION);
				glLoadIdentity(); // Nicht vergessen!
				gluPerspective(40.0, (r.right-r.left)/(double)(r.bottom-r.top), 1.0, 40.0);
				// noch unschn: Division durch null, wenn Hhe gleich null;
				// besser durch Vergleich abfangen
			}
			break;
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Menauswahlen analysieren:
			switch( wmId ) 
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow( hWnd );
				   break;
				default:
				   return DefWindowProc( hWnd, message, wParam, lParam );
			}
			break;
		case WM_PAINT: // jl
			{
				wglMakeCurrent(hDC, hRC);
				glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

				glMatrixMode(GL_MODELVIEW);
				glLoadIdentity();

				glTranslated(0.0, 0.0, -5.0);
				glRotated(angleH, 0.0, 1.0, 0.0);
				glRotated(angleV, 1.0, 0.0, 0.0);

				GLfloat lightPos[] = {-1.5f, 0.4f, 0.3f, 1.0f}; // GLFloat, nicht double!
				// Wird mit MODELVIEW multipliziert!
				
				glLightfv(GL_LIGHT0, GL_POSITION, lightPos); // nicht in glBegin...glEnd erlaubt

				// Alles, was gleich bleibt, knnte man einfach
				// einmal zu Beginn initialisieren und dann
				// nie wieder anfassen.
	
				// fr MIP-Map:
				// glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
				// sonst:
				glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
				glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
				// GL_REPLACE, GL_MODULATE, GL_DECAL
				glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
				glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA,
					texWidth, texHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE,
					myTexture);
				// oder um eine MIP-Map einzurichten:
				// gluBuild2DMipmaps(GL_TEXTURE_2D, 4,
				//	texWidth, texHeight, GL_RGBA, GL_UNSIGNED_BYTE,
				//	myTexture);

				glEnable(GL_LIGHT0); // Licht Nr. 0 anschalten
				GLfloat diffCol[] = {1.0f, 1.0f, 0.4f, 1.0f};
				glLightfv(GL_LIGHT0, GL_DIFFUSE, diffCol);
				GLfloat specCol[] = {1.0f, 1.0f, 1.0f, 1.0f};
				glLightfv(GL_LIGHT0, GL_SPECULAR, specCol);
				GLfloat ambCol[] = {0.2f, 0.2f, 0.2f, 1.0f};
				glLightfv(GL_LIGHT0, GL_AMBIENT, ambCol);

				GLfloat matDiffCol[] = {1.0f, 1.0f, 1.0f, 1.0f};
				glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, matDiffCol);
				GLfloat matSpecCol[] = {1.0f, 1.0f, 1.0f, 1.0f};
				glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, matSpecCol);
				glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, 256.0);
				GLfloat matAmbCol[] = {1.0f, 1.0f, 1.0f, 1.0f};
				glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, matAmbCol);
				GLfloat matEmCol[] = {0.1f, 0.0f, 0.0f, 1.0f};
				glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, matEmCol);

				glEnable(GL_DEPTH_TEST);

				// glCullFace(GL_FRONT);
				// glFrontFace(GL_CW);
				glEnable(GL_CULL_FACE);

				glEnable(GL_LIGHTING);

				// Bei transparenten Flchen wird die Reihenfolge wichtig!
				// drawUnitSphere(90, 45);

				glEnable(GL_TEXTURE_2D);
				// glEnable(GL_BLEND);
				// glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

				glBegin(GL_QUADS);
					glNormal3d(0.0, 1.0, 0.0);
					glTexCoord2d(0.0, 0.0);
					glVertex3d(-2.0, 0.0,  2.0);
					glTexCoord2d(1.0, 0.0);
					glVertex3d( 2.0, 0.0,  2.0);
					glTexCoord2d(1.0, 1.0);
					glVertex3d( 2.0, 0.0, -2.0);
					glTexCoord2d(0.0, 1.0);
					glVertex3d(-2.0, 0.0, -2.0);

					glNormal3d(0.0, -1.0, 0.0);
					glTexCoord2d(0.1, 0.1);
					glVertex3d(-2.0, -0.01,  2.0);
					glTexCoord2d(0.3, 0.1);
					glVertex3d(-2.0, -0.01, -2.0);
					glTexCoord2d(0.3, 0.3);
					glVertex3d( 2.0, -0.01, -2.0);
					glTexCoord2d(0.1, 0.3);
					glVertex3d( 2.0, -0.01,  2.0);
				glEnd();

				glDisable(GL_BLEND);
				glDisable(GL_TEXTURE_2D);
				glDisable(GL_LIGHTING);
				glDisable(GL_CULL_FACE);

				// zur Demonstration Lichtquelle markieren
				glPointSize(5);
				glColor3f(1.0, 0.0, 0.0);
				glBegin(GL_POINTS);
					glVertex4fv(lightPos);
				glEnd();				

				glDisable(GL_DEPTH_TEST);

				SwapBuffers(hDC);

				ValidateRect(hWnd, NULL);
			}
			break;
		case WM_CHAR: // jl
			switch(wParam)
			{
				case 'h':
					angleH += 5.0;
					InvalidateRect(hWnd, NULL, FALSE);
					break;
				case 'v':
					angleV += 5.0;
					InvalidateRect(hWnd, NULL, FALSE);
					break;
				default: ;
			}
			break;
		case WM_DESTROY:
			wglMakeCurrent(hDC, NULL); // jl: neu
			wglDeleteContext(hRC); // jl: neu
			PostQuitMessage( 0 );
			break;
		default:
			return DefWindowProc( hWnd, message, wParam, lParam );
   }
   return 0;
}

// Nachrichtenbehandlungsroutine fr "Info"-Feld.
LRESULT CALLBACK About( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch( message )
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
